﻿/* Copyright (c) 2011-2012, Zetatron Consulting
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

* Neither the name of Zetatron Consulting nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using System.IO;

namespace AuthenticationServer.Services
{
    public struct RealmInformations
    {
        [XmlAttribute(AttributeName="ID")]
        public byte ID;
        [XmlAttribute(AttributeName="IP")]
        public string Address;
        [XmlAttribute(AttributeName="Port")]
        public short Port;
        [XmlAttribute(AttributeName = "MaxPlayers")]
        public short MaxPlayers;
    }

    [XmlRoot(ElementName = "WorldServers")]
    public class RealmTable
    {
        [XmlElement(ElementName = "WorldServer")]
        public List<RealmInformations> Realms;
    }

    public class RealmService
    {
        public static RealmTable Realms;

        public static void Initialize()
        {
            XmlSerializer ser = new XmlSerializer(typeof(RealmTable));
            using (StreamReader rdr = new StreamReader("WorldServers.xml"))
            {
                Realms = (RealmTable)ser.Deserialize(rdr);
            }
        }
    }
}
