﻿/* Copyright (c) 2011-2012, Zetatron Consulting
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

* Neither the name of Zetatron Consulting nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AionCxxLibrary.Enums;

namespace AionCxxLibrary.Models
{
    public class TCharacter
    {
        public int ID;
        public int AccountID;
        public string Name;
        public CharacterClass Class;
        public Race Race;
        public byte Level;
        public long Experience;
        public long ExperienceRecoverable;
        public byte Gender; // 0 = Male, 1 = Female, 2 = All
        public byte Title;
        public TCharacterAppearance Appearance;
        public int WorldID;
        public Vector4D Position;
        public List<TItem> Equipment;
        public string Note;
    }

    public class TItem
    {
        public int ItemID;
        public int ItemColor;
    }

    public class TCharacterAppearance
    {
        public byte Voice;
        public int RGB_Skin;
        public int RGB_Hair;
        public int RGB_Eye;
        public int RGB_Lip;
        public float Height;

        public byte Face;
        public byte Hair;
        public byte Decoration;
        public byte Tattoo;
        public byte FaceContour;
        public byte Expression;
        public byte Jawline;
        public byte Forehead;
        public byte EyeHeight;
        public byte EyeSpace;
        public byte EyeWidth;
        public byte EyeSize;
        public byte EyeShape;
        public byte EyeAngle;
        public byte BrowHeight;
        public byte BrowAngle;
        public byte BrowShape;
        public byte Nose;
        public byte NoseBridge;
        public byte NoseWidth;
        public byte NoseTip;
        public byte Cheek;
        public byte LipHeight;
        public byte MouthSize;
        public byte LipSize;
        public byte Smile;
        public byte LipShape;
        public byte JawHeight;
        public byte ChinJut;
        public byte EarShape;
        public byte HeadSize;
        public byte Neck;
        public byte NeckLength;
        public byte ShoulderSize;
        public byte Torso;
        public byte Chest;
        public byte Waist;
        public byte Hips;
        public byte ArmThickness;
        public byte HandSize;
        public byte LegThickness;
        public byte LegLength;
        public byte FacialRate;
        public byte ArmLength;
        public byte FeetSize;
        public byte Shoulders;
        public byte FaceShape;
    }

}
