﻿/* Copyright (c) 2011-2012, Zetatron Consulting
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

* Neither the name of Zetatron Consulting nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using WorldServer.Data;
using WorldServer.Data.Templates;

namespace WorldServer.Commands
{
    public class Debug : CxxCommand<Debug>
    {
        protected override void Execute(Models.Character sender, string[] parameters)
        {
            if (parameters[0] == "xmlunk")
            {
                List<string> unkElems = new List<string>();
                switch (parameters[1])
                {
                    case "skill":
                    case "skills":
                        foreach (SkillTemplate skt in Datastore.SkillsByName.Values.Where(sk => sk.OtherElements != null && sk.OtherElements.Count > 0))
                        {
                            foreach (XmlElement elem in skt.OtherElements)
                            {
                                if (!unkElems.Contains(elem.Name))
                                    unkElems.Add(elem.Name);
                            }
                        }
                        break;
                    case "npc":
                        foreach (NPCTemplate npct in Datastore.NpcsByName.Values.Where(t => t.OtherElements != null && t.OtherElements.Count > 0))
                        {
                            foreach (XmlElement elem in npct.OtherElements)
                            {
                                if (!unkElems.Contains(elem.Name))
                                    unkElems.Add(elem.Name);
                            }
                        }
                        break;
                }
                Console.WriteLine("Found " + unkElems.Count + " unknown elements.");
                foreach (string elem in unkElems)
                {
                    Console.WriteLine("Element: " + elem);
                }
            }
        }
    }
}
