﻿/* Copyright (c) 2011-2012, Zetatron Consulting
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

* Neither the name of Zetatron Consulting nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AionCxxLibrary.Utilities;
using WorldServer.Packets.Server;

namespace WorldServer.Models
{
    public delegate void ResponseDelegate(bool OK);

    public class UIQuestion
    {
        public int MessageID;
        public ResponseDelegate RespDelegate;

        public UIQuestion(int MessageID, ResponseDelegate del)
        {
            this.MessageID = MessageID;
            this.RespDelegate = del;
        }
    }

    public class AionDescription
    {
        public int DescriptionID;
        public AionDescription(int Description)
        {
            DescriptionID = Description;
        }
    }

    public class UI
    {
        public List<UIQuestion> Questions = new List<UIQuestion>();
        public Character Owner;
        
        public UI(Character owner)
        {
            this.Owner = owner;
        }

        public void AskQuestion(int messageId, int senderId, ResponseDelegate responseDelegate, params object[] parameters)
        {
            Questions.Add(new UIQuestion(messageId, responseDelegate));
            Owner.SendPacket(new SPkt_UIQuestion(senderId, messageId, parameters));
        }

        public void QuestionResponse(int guid, bool ok)
        {
            UIQuestion question = Questions.Find(q => q.MessageID == guid);
            if (question != null)
            {
                question.RespDelegate.DynamicInvoke(ok);
                Questions.Remove(question);
            }
        }

    }

}
