﻿/* Copyright (c) 2011-2012, Zetatron Consulting
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

* Neither the name of Zetatron Consulting nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AionCxxLibrary.Packets;
using WorldServer.Models;

namespace WorldServer.Packets.Server
{
    public class QuestListServerPacket : AionServerPacket
    {
        protected List<QuestInfo> Quests;
        public QuestListServerPacket(List<QuestInfo> quests)
        {
            Quests = quests;
        }
        public override void WritePacket()
        {
            WriteShort(1);
            WriteUnsignedShort((ushort)Quests.Count);
        }
    }

    public class SPkt_QuestsCurrent : QuestListServerPacket
    {
        public SPkt_QuestsCurrent(List<QuestInfo> quests) : base(quests) { }
        public override void WritePacket()
        {
            base.WritePacket();
            foreach (QuestInfo qi in Quests)
            {
                WriteUnsignedShort((ushort)qi.QuestID);
                WriteUnsignedShort(0);
                WriteByte((byte)(int)qi.Status);
                WriteInt(qi.QuestVar);
                WriteByte(0);
            }
        }
    }

    public class SPkt_QuestsCompleted : QuestListServerPacket
    {
        public SPkt_QuestsCompleted(List<QuestInfo> quests) : base(quests) { }
        public override void WritePacket()
        {
            base.WritePacket();
            foreach (QuestInfo qi in Quests)
            {
                WriteUnsignedShort((ushort)qi.QuestID);
                WriteUnsignedShort(0);
                WriteByte(qi.CompletedTimes);
            }
        }
    }
}
